/* "CodeWorker":	a scripting language for parsing and generating text.

Copyright (C) 1996-1997, 1999-2002 Cdric Lemaire

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

To contact the author: codeworker@free.fr
*/

#ifdef WIN32
#pragma warning (disable : 4786)
#endif

#include "DtaScriptVariable.h"
#include "DtaProject.h"
#include "ScpStream.h"
#include "UtlTimer.h"
#include "CppCompilerEnvironment.h"
#include "GrfDelay.h"

using namespace CodeWorker;

GrfDelay::~GrfDelay() {}

SEQUENCE_INTERRUPTION_LIST GrfDelay::executeInternal(DtaScriptVariable& visibility) {
	SEQUENCE_INTERRUPTION_LIST result;
	UtlTimer timer;
	timer.start();
	result = GrfBlock::executeInternal(visibility);
	timer.stop();
	double dDuration = timer.getTimeInSec();
	DtaProject::getInstance().setLastDelay(dDuration);
	return result;
}

void GrfDelay::compileCpp(CppCompilerEnvironment& theCompilerEnvironment) const {
	theCompilerEnvironment.getBody() << theCompilerEnvironment.getIndentation() << "clock_t _compiler_start = clock();";
	theCompilerEnvironment.getBody().endl();
	theCompilerEnvironment.getBody() << theCompilerEnvironment.getIndentation() << "clock_t _compiler_finish = clock();";
	theCompilerEnvironment.getBody().endl();
	theCompilerEnvironment.getBody() << theCompilerEnvironment.getIndentation();
	GrfBlock::compileCpp(theCompilerEnvironment);
	theCompilerEnvironment.getBody() << theCompilerEnvironment.getIndentation() << "double _compiler_duration = (double)(_compiler_finish - _compiler_start) / CLOCKS_PER_SEC;";
	theCompilerEnvironment.getBody().endl();
	theCompilerEnvironment.getBody() << theCompilerEnvironment.getIndentation() << "CGRuntime::setLastDelay(_compiler_duration);";
	theCompilerEnvironment.getBody().endl();
}
