/* "CodeWorker":	a scripting language for parsing and generating text.

Copyright (C) 1996-1997, 1999-2002 Cdric Lemaire

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

To contact the author: codeworker@free.fr
*/

#ifdef WIN32
#pragma warning (disable : 4786)
#endif

#include "UtlException.h"
#include "DtaScriptVariable.h"
#include "ExprScriptVariable.h"
#include "ScpStream.h"
#include "CppCompilerEnvironment.h"
#include "GrfPushItem.h"

using namespace CodeWorker;

GrfPushItem::~GrfPushItem() {
	if (_pVariable != 0L) delete _pVariable;
	if (_pValue != 0L) delete _pValue;
}

SEQUENCE_INTERRUPTION_LIST GrfPushItem::executeInternal(DtaScriptVariable& visibility) {
	DtaScriptVariable* pVariable = visibility.getVariable(*_pVariable);
	std::string sValue;
	if (_pValue != 0L) sValue = _pValue->getValue(visibility);
	pVariable->pushItem(sValue);
	return NO_INTERRUPTION;
}

void GrfPushItem::compileCpp(CppCompilerEnvironment& theCompilerEnvironment) const {
	theCompilerEnvironment.getBody() << theCompilerEnvironment.getIndentation();
	_pVariable->compileCppForSet(theCompilerEnvironment);
	theCompilerEnvironment.getBody() << ".pushItem(";
	if (_pValue != 0L) _pValue->compileCpp(theCompilerEnvironment);
	else theCompilerEnvironment.getBody() << "\"\"";
	theCompilerEnvironment.getBody() << ");";
	theCompilerEnvironment.getBody().endl();
}

